/*******************************************************************************
 * Copyright (c) 2012 IBM Corporation and others.
 *
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * and Eclipse Distribution License v. 1.0 which accompanies this distribution.
 *
 * The Eclipse Public License is available at http://www.eclipse.org/legal/epl-v10.html
 * and the Eclipse Distribution License is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * Contributors:
 *
 *     Michael Fiedler     - initial API and implementation for Bugzilla adapter
 *     Jad El-khoury        - initial implementation of code generator (https://bugs.eclipse.org/bugs/show_bug.cgi?id=422448)
 *
 * This file is generated by org.eclipse.lyo.oslc4j.codegenerator
 *******************************************************************************/
package se.kth.md.adaptors.basicexample.services;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.HeaderParam;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.core.UriBuilder;

import org.apache.wink.json4j.JSONObject;
import org.eclipse.lyo.oslc4j.provider.json4j.JsonHelper;
import org.eclipse.lyo.oslc4j.core.annotation.OslcCreationFactory;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDialog;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDialogs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcQueryCapability;
import org.eclipse.lyo.oslc4j.core.annotation.OslcService;
import org.eclipse.lyo.oslc4j.core.model.Compact;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.OslcMediaType;
import org.eclipse.lyo.oslc4j.core.model.Preview;
import org.eclipse.lyo.oslc4j.core.model.ServiceProvider;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;

import se.kth.md.adaptors.basicexample.BasicAdaptorManager;
import se.kth.md.adaptors.basicexample.BasicAdaptorConstants;
import se.kth.md.adaptors.basicexample.servlet.ServiceProviderCatalogSingleton;
import se.kth.md.adaptors.basicexample.resources.Developer;
import se.kth.md.adaptors.basicexample.resources.ExtendedRequirement;
import se.kth.md.adaptors.basicexample.resources.Person;
import se.kth.md.adaptors.basicexample.resources.Requirement;
import se.kth.md.adaptors.basicexample.resources.SoftwareProduct;

// Start of user code imports
// End of user code

// Start of user code pre_class_code
// End of user code
@OslcService(BasicAdaptorConstants.BASICDOMAIN_DOMAIN)
@Path("bd-services/{serviceProviderId}/resources")
public class SoftwareProductAndDeveloperService
{
    @Context private HttpServletRequest httpServletRequest;
    @Context private HttpServletResponse httpServletResponse;
    @Context private UriInfo uriInfo;

    // Start of user code class_attributes
    // End of user code

    // Start of user code class_methods
    // End of user code

    public SoftwareProductAndDeveloperService()
    {
        super();
    }

    @OslcQueryCapability
    (
        title = "QueryCapabilitySoftwareProducts",
        label = "QueryCapabilitySoftwareProducts",
        resourceShape = OslcConstants.PATH_RESOURCE_SHAPES + "/" + BasicAdaptorConstants.PATH_SOFTWAREPRODUCT,
        resourceTypes = {BasicAdaptorConstants.TYPE_SOFTWAREPRODUCT},
        usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("softwareproducts")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public SoftwareProduct[] querySoftwareProducts(
                                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                                     @QueryParam("oslc.where") final String where,
                                                     @QueryParam("page") final String pageString,
                                                    @QueryParam("limit") final String limitString) throws IOException, ServletException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code querySoftwareProducts
        // Here additional logic can be implemented that complements main action taken in BasicAdaptorManager
        // End of user code

        final List<SoftwareProduct> resources = BasicAdaptorManager.querySoftwareProducts(httpServletRequest, serviceProviderId, where, page, limit);
        return resources.toArray(new SoftwareProduct [resources.size()]);
    }

    @GET
    @Path("softwareproducts")
    @Produces({ MediaType.TEXT_HTML })
    public Response querySoftwareProductsAsHtml(
                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                       @QueryParam("oslc.where") final String where,
                                       @QueryParam("page") final String pageString,
                                    @QueryParam("limit") final String limitString) throws ServletException, IOException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code querySoftwareProductsAsHtml
        // End of user code

        final List<SoftwareProduct> resources = BasicAdaptorManager.querySoftwareProducts(httpServletRequest, serviceProviderId, where, page, limit);

        if (resources!= null) {
            httpServletRequest.setAttribute("resources", resources);
            // Start of user code querySoftwareProductsAsHtml_setAttributes
            // End of user code

            httpServletRequest.setAttribute("queryUri",
                    uriInfo.getAbsolutePath().toString() + "?oslc.paging=true");
            if (resources.size() > limit) {
                resources.remove(resources.size() - 1);
                httpServletRequest.setAttribute("nextPageUri",
                        uriInfo.getAbsolutePath().toString() + "?oslc.paging=true&amp;page=" + (page + 1));
            }
            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/softwareproductscollection.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @OslcQueryCapability
    (
        title = "QueryCapabilityDevelopers",
        label = "QueryCapabilityDevelopers",
        resourceShape = OslcConstants.PATH_RESOURCE_SHAPES + "/" + BasicAdaptorConstants.PATH_DEVELOPER,
        resourceTypes = {BasicAdaptorConstants.TYPE_DEVELOPER},
        usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("developers")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public Developer[] queryDevelopers(
                                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                                     @QueryParam("oslc.where") final String where,
                                                     @QueryParam("page") final String pageString,
                                                    @QueryParam("limit") final String limitString) throws IOException, ServletException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryDevelopers
        // Here additional logic can be implemented that complements main action taken in BasicAdaptorManager
        // End of user code

        final List<Developer> resources = BasicAdaptorManager.queryDevelopers(httpServletRequest, serviceProviderId, where, page, limit);
        return resources.toArray(new Developer [resources.size()]);
    }

    @GET
    @Path("developers")
    @Produces({ MediaType.TEXT_HTML })
    public Response queryDevelopersAsHtml(
                                    @PathParam("serviceProviderId") final String serviceProviderId ,
                                       @QueryParam("oslc.where") final String where,
                                       @QueryParam("page") final String pageString,
                                    @QueryParam("limit") final String limitString) throws ServletException, IOException
    {
        int page=0;
        int limit=20;
        if (null != pageString) {
            page = Integer.parseInt(pageString);
        }
        if (null != limitString) {
            limit = Integer.parseInt(limitString);
        }

        // Start of user code queryDevelopersAsHtml
        // End of user code

        final List<Developer> resources = BasicAdaptorManager.queryDevelopers(httpServletRequest, serviceProviderId, where, page, limit);

        if (resources!= null) {
            httpServletRequest.setAttribute("resources", resources);
            // Start of user code queryDevelopersAsHtml_setAttributes
            // End of user code

            httpServletRequest.setAttribute("queryUri",
                    uriInfo.getAbsolutePath().toString() + "?oslc.paging=true");
            if (resources.size() > limit) {
                resources.remove(resources.size() - 1);
                httpServletRequest.setAttribute("nextPageUri",
                        uriInfo.getAbsolutePath().toString() + "?oslc.paging=true&amp;page=" + (page + 1));
            }
            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/developerscollection.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @OslcDialog
    (
         title = "DeveloperSelectionDialog",
         label = "DeveloperSelectionDialog",
         uri = "bd-services/{serviceProviderId}/resources/developerSelector",
         hintWidth = "45px",
         hintHeight = "10px",
         resourceTypes = {BasicAdaptorConstants.TYPE_DEVELOPER},
         usages = {OslcConstants.OSLC_USAGE_DEFAULT}
    )
    @GET
    @Path("developerSelector")
    @Consumes({ MediaType.TEXT_HTML, MediaType.WILDCARD })
    public void DeveloperSelector(
        @QueryParam("terms") final String terms
        , @PathParam("serviceProviderId") final String serviceProviderId
        ) throws ServletException, IOException
    {
        try {
            // Start of user code DeveloperSelector_init
            // End of user code

            httpServletRequest.setAttribute("selectionUri",uriInfo.getAbsolutePath().toString());
            // Start of user code DeveloperSelector_setAttributes
            // End of user code

            if (terms != null ) {
                httpServletRequest.setAttribute("terms", terms);
                final List<Developer> resources = BasicAdaptorManager.DeveloperSelector(httpServletRequest, serviceProviderId, terms);
                if (resources!= null) {
                            httpServletRequest.setAttribute("resources", resources);
                            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/developerselectorresults.jsp");
                            rd.forward(httpServletRequest, httpServletResponse);
                }
                //a empty search should return an empty list and not NULL!
                throw new WebApplicationException(Status.NOT_FOUND);

            } else {
                try {
                    RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/developerselector.jsp");
                    rd.forward(httpServletRequest, httpServletResponse);
                } catch (Exception e) {
                    throw new ServletException(e);
                }
            }
        } catch (Exception e) {
            throw new WebApplicationException(e);
        }
    }

    @GET
    @Path("developers/{resourceId}")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public Developer getDeveloper(
                @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code getResource_init
        // End of user code

        final Developer aDeveloper = BasicAdaptorManager.getDeveloper(httpServletRequest, serviceProviderId, resourceId);

        if (aDeveloper != null) {
            // Start of user code getDeveloper
            // End of user code
            return aDeveloper;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

	@GET
    @Path("developers/{resourceId}")
	@Produces({OslcMediaType.APPLICATION_X_OSLC_COMPACT_XML})
    public Compact getDeveloperCompact(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getDeveloperAsHtml_init
        // End of user code

        final Developer aDeveloper = BasicAdaptorManager.getDeveloper(httpServletRequest, serviceProviderId, resourceId);

        if (aDeveloper != null) {
            final Compact compact = new Compact();

            compact.setAbout(aDeveloper.getAbout());

            //String iconUri = "https://landfill.bugzilla.org/bugzilla-4.4-branch/images/favicon.ico";
            //compact.setIcon(new URI(iconUri));

            //Create and set attributes for OSLC preview resource
            final Preview smallPreview = new Preview();
            smallPreview.setHintHeight("11em");
            smallPreview.setHintWidth("45em");
            smallPreview.setDocument(new URI(compact.getAbout().toString() + "/smallPreview"));
            compact.setSmallPreview(smallPreview);

            //Use the HTML representation of a change request as the large preview as well
            final Preview largePreview = new Preview();
            largePreview.setHintHeight("20em");
            largePreview.setHintWidth("45em");
            largePreview.setDocument(compact.getAbout());
            compact.setLargePreview(largePreview);

            return compact;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

	@GET
    @Path("developers/{resourceId}/smallPreview")
    @Produces({ MediaType.TEXT_HTML })
    public void getDevelopersmallPreview (
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getDeveloperAsHtml_init
        // End of user code

        final Developer aDeveloper = BasicAdaptorManager.getDeveloper(httpServletRequest, serviceProviderId, resourceId);

        if (aDeveloper != null) {
            httpServletRequest.setAttribute("aDeveloper", aDeveloper);

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/developer_preview_small.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
            return;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("developers/{resourceId}")
    @Produces({ MediaType.TEXT_HTML })
    public Response getDeveloperAsHtml(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getDeveloperAsHtml_init
        // End of user code

        final Developer aDeveloper = BasicAdaptorManager.getDeveloper(httpServletRequest, serviceProviderId, resourceId);

        if (aDeveloper != null) {
            httpServletRequest.setAttribute("aDeveloper", aDeveloper);
            // Start of user code getDeveloperAsHtml_setAttributes
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/developer.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("softwareProducts/{resourceId}")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public SoftwareProduct getSoftwareProduct(
                @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code getResource_init
        // End of user code

        final SoftwareProduct aSoftwareProduct = BasicAdaptorManager.getSoftwareProduct(httpServletRequest, serviceProviderId, resourceId);

        if (aSoftwareProduct != null) {
            // Start of user code getSoftwareProduct
            // End of user code
            return aSoftwareProduct;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

	@GET
    @Path("softwareProducts/{resourceId}")
	@Produces({OslcMediaType.APPLICATION_X_OSLC_COMPACT_XML})
    public Compact getSoftwareProductCompact(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getSoftwareProductAsHtml_init
        // End of user code

        final SoftwareProduct aSoftwareProduct = BasicAdaptorManager.getSoftwareProduct(httpServletRequest, serviceProviderId, resourceId);

        if (aSoftwareProduct != null) {
            final Compact compact = new Compact();

            compact.setAbout(aSoftwareProduct.getAbout());

            //String iconUri = "https://landfill.bugzilla.org/bugzilla-4.4-branch/images/favicon.ico";
            //compact.setIcon(new URI(iconUri));

            //Create and set attributes for OSLC preview resource
            final Preview smallPreview = new Preview();
            smallPreview.setHintHeight("11em");
            smallPreview.setHintWidth("45em");
            smallPreview.setDocument(new URI(compact.getAbout().toString() + "/smallPreview"));
            compact.setSmallPreview(smallPreview);

            //Use the HTML representation of a change request as the large preview as well
            final Preview largePreview = new Preview();
            largePreview.setHintHeight("20em");
            largePreview.setHintWidth("45em");
            largePreview.setDocument(compact.getAbout());
            compact.setLargePreview(largePreview);

            return compact;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

	@GET
    @Path("softwareProducts/{resourceId}/smallPreview")
    @Produces({ MediaType.TEXT_HTML })
    public void getSoftwareProductsmallPreview (
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getSoftwareProductAsHtml_init
        // End of user code

        final SoftwareProduct aSoftwareProduct = BasicAdaptorManager.getSoftwareProduct(httpServletRequest, serviceProviderId, resourceId);

        if (aSoftwareProduct != null) {
            httpServletRequest.setAttribute("aSoftwareProduct", aSoftwareProduct);

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/softwareproduct_preview_small.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
            return;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("softwareProducts/{resourceId}")
    @Produces({ MediaType.TEXT_HTML })
    public Response getSoftwareProductAsHtml(
        @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getSoftwareProductAsHtml_init
        // End of user code

        final SoftwareProduct aSoftwareProduct = BasicAdaptorManager.getSoftwareProduct(httpServletRequest, serviceProviderId, resourceId);

        if (aSoftwareProduct != null) {
            httpServletRequest.setAttribute("aSoftwareProduct", aSoftwareProduct);
            // Start of user code getSoftwareProductAsHtml_setAttributes
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/se/kth/md/adaptors/basicexample/softwareproduct.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @PUT
    @Path("developers/{resourceId}")
    @Consumes({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public Response updateDeveloper(
            @HeaderParam("If-Match") final String eTagHeader,
            @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId ,
            final Developer aResource
        ) throws IOException, ServletException
    {
        // Start of user code updateDeveloper_init
        // End of user code
        final Developer originalResource = BasicAdaptorManager.getDeveloper(httpServletRequest, serviceProviderId, resourceId);

        if (originalResource != null) {
            try {
                final String originalETag = BasicAdaptorManager.getETagFromDeveloper(originalResource);

                if ((eTagHeader == null) || (originalETag.equals(eTagHeader))) {
                    // Start of user code updateDeveloper
                    // End of user code
                    final Developer updatedResource = BasicAdaptorManager.updateDeveloper(httpServletRequest, aResource, serviceProviderId, resourceId);
                    httpServletResponse.setHeader("ETag", BasicAdaptorManager.getETagFromDeveloper(updatedResource));
                    return Response.ok().build();
                }
                else {
                    throw new WebApplicationException(Status.PRECONDITION_FAILED);
                }

            } catch (Exception e) {
                e.printStackTrace();
                throw new WebApplicationException(e);
            }

        }
        else {
            throw new WebApplicationException(Status.NOT_FOUND);
        }
    }


    @PUT
    @Path("softwareProducts/{resourceId}")
    @Consumes({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    public Response updateSoftwareProduct(
            @HeaderParam("If-Match") final String eTagHeader,
            @PathParam("serviceProviderId") final String serviceProviderId, @PathParam("resourceId") final String resourceId ,
            final SoftwareProduct aResource
        ) throws IOException, ServletException
    {
        // Start of user code updateSoftwareProduct_init
        // End of user code
        final SoftwareProduct originalResource = BasicAdaptorManager.getSoftwareProduct(httpServletRequest, serviceProviderId, resourceId);

        if (originalResource != null) {
            try {
                final String originalETag = BasicAdaptorManager.getETagFromSoftwareProduct(originalResource);

                if ((eTagHeader == null) || (originalETag.equals(eTagHeader))) {
                    // Start of user code updateSoftwareProduct
                    // End of user code
                    final SoftwareProduct updatedResource = BasicAdaptorManager.updateSoftwareProduct(httpServletRequest, aResource, serviceProviderId, resourceId);
                    httpServletResponse.setHeader("ETag", BasicAdaptorManager.getETagFromSoftwareProduct(updatedResource));
                    return Response.ok().build();
                }
                else {
                    throw new WebApplicationException(Status.PRECONDITION_FAILED);
                }

            } catch (Exception e) {
                e.printStackTrace();
                throw new WebApplicationException(e);
            }

        }
        else {
            throw new WebApplicationException(Status.NOT_FOUND);
        }
    }


}
